--------------------------------------------------------------------------------
-- Weapon: Scales of Justicia
-- by Kiffer-Opa
-- GFX by Puwanart Triamkarn <http://www.mynamenone.co.cc/>
--------------------------------------------------------------------------------


-- Setup Tables
if kifferopa==nil then kifferopa={} end
kifferopa.justicia={}

-- Load & Prepare Ressources
kifferopa.justicia.gfx_hand=loadgfx("weapons/push.bmp")
kifferopa.justicia.gfx_wpn=loadgfx("weapons/scales.png")						-- Weapon Image
kifferopa.justicia.gfx_icon=loadgfx("weapons/scales_icon.png")
setmidhandle(kifferopa.justicia.gfx_wpn)
setmidhandle(kifferopa.justicia.gfx_icon)
kifferopa.justicia.sfx_attack=loadsfx("Gong.ogg")


kifferopa.justicia.id=addweapon("kifferopa.justicia","Scales of Justicia",kifferopa.justicia.gfx_icon,0,2)			-- Add Weapon

function kifferopa.justicia.draw()												-- Draw
	if (weapon_shots<=0) then
		if getplayeraction(0)==0 then
			setblend(blend_alpha)
			setalpha(1)
			setcolor(255,255,255)
			setscale(-getplayerdirection(0),1)
			setrotation(0)
			drawimage(kifferopa.justicia.gfx_wpn, getplayerx(0)+getplayerdirection(0)*(7+weapon_timer),getplayery(0)+10)
			drawimage(kifferopa.justicia.gfx_hand,getplayerx(0)+getplayerdirection(0)*(7+weapon_timer),getplayery(0)+5)

		end
	end
end

function kifferopa.justicia.sethealth(player,targethealth)
	local currenthealth = getplayerhealth(player)
	
	if(currenthealth>targethealth) then
		playerdamage(player, currenthealth-targethealth)
	elseif(currenthealth<averagehealth) then
		playerheal(player, targethealth-currenthealth)
	end
end

function kifferopa.justicia.attack(attack)										-- Attack
	if (weapon_shots<=0) then
		if (attack==1) then
			-- No more weapon switching!
			useweapon(0)
			weapon_shots=weapon_shots+1
			
			local totalhealth = 0
			local players = 0
			local teammembers = {0, 0, 0, 0, 0, 0, 0, 0}
			for p=1,#playertable() do
				local player = playertable()[p]
			
				if(getplayerhealth(player)>=1) then
					totalhealth = totalhealth+getplayerhealth(playertable()[p])
					players = players+1
					teammembers[getplayerteam(player)+1] = teammembers[getplayerteam(player)+1]+1
				end
			end

			local teams = 0
			for t=1,#teammembers do
				if(teammembers[t]>0) then
					teams = teams+1
				end
			end
			local averageteamhealth = totalhealth/teams
			for p=1,#playertable() do
				local player = playertable()[p]
				local health = getplayerhealth(player)
					if(health>=1) then
					averagehealth = averageteamhealth / teammembers[getplayerteam(player)+1]
					kifferopa.justicia.sethealth(player,averagehealth)
				end
			end	
			
			-- SFX
			playsound(kifferopa.justicia.sfx_attack)
			
			-- End Turn
			endturn()
		end
	end
end